#include "asset.h"
#include "byteorder.h"
#include "file.h"
#include "filebase.h"
#include "quicktime.h"



FileBase::FileBase(Asset *asset, File *file)
{
	this->file = file;
	this->asset = asset;
	this->mwindow = file->mwindow;
	internal_byte_order = get_byte_order();
	reset_parameters();
	cached_frames = 0;
	read_buffer = 0;
	read_size = 0;
}

FileBase::~FileBase()
{
	if(cached_frames)
	{
	   delete_cache();
	}
	if(read_buffer)
		delete read_buffer;
	
	read_buffer = 0;
}

int FileBase::close_file()
{
	close_file_derived();
	delete_cache();
	reset_parameters();
	return 0;
}

int FileBase::reset_parameters()
{
	reset_parameters_derived();
	return 0;
}


int FileBase::match4(char *in, char *out)
{
	if(in[0] == out[0] &&
		in[1] == out[1] &&
		in[2] == out[2] &&
		in[3] == out[3])
	return 1;
	else
	return 0;
}

int FileBase::delete_cache()
{
	if(cached_frames)
	{
		for(int i = 0; i < cached_frames; i++)
		{
			delete ram_cache[i];
		}
		delete ram_cache;
	}
	cached_frames = 0;
	return 0;
}

int FileBase::get_read_buffer(long len)
{
	if(read_size != len)
	{
		delete read_buffer;
		read_buffer = 0;
	}
	
	if(!read_buffer) read_buffer = new BCBASE_INT16[len];
	read_size = len;
	return 0;
}
