#ifndef FILEMOV_H
#define FILEMOV_H

#include "file.inc"
#include "filebase.h"
#include "quicktime.h"

class FileMOV : public FileBase
{
public:
	FileMOV(Asset *asset, File *file);
	~FileMOV();

	int open_file();
	int close_file_derived();
	int read_header();
	long get_video_length();
	long get_audio_length();
	int get_position(double &percentage, double &seconds);
	long get_video_position();
	long get_audio_position();
	int end_of_audio();
	int end_of_video();
	int set_position(double percentage);
	int set_video_position(long x);
	int set_audio_position(long x);
	int drop_frames(int frames);
	int frame_back();

	int read_audio(char *buffer, long len);
	int read_frame(unsigned char *frame);
	int load_into_ram();

private:
	int reset_parameters_derived();
// current positions for when the file descriptor doesn't have the right position
	long audio_position;
	long video_position;
	quicktime_t *file;
};





#endif
