#ifndef PLAYBACKENGINE_H
#define PLAYBACKENGINE_H

#include "arender.inc"
#include "mainwindow.inc"
#include "mwindowgui.inc"
#include "mutex.h"
#include "thread.h"
#include "timer.h"
#include "vrender.inc"


class PlaybackEngine : public Thread
{
public:
	PlaybackEngine(MainWindow *mwindow);
	~PlaybackEngine();

	void run();

	int reset_parameters();
	int start_playback();
	int stop_playback();   // interrupt while playing
	int close_playback();  // normal ending
	int wait_for_startup();
	int current_position(double &percentage, double &seconds);
	long PlaybackEngine::current_sample();

	int playing_back;
	ARender *arender;
	VRender *vrender;
	PlaybackScroll *scroll;
	MainWindow *mwindow;
	Mutex startup_lock;
	Mutex complete;
	Timer timer;
	long starting_sample;  // Starting sample for audio-only positioning
};




#endif
