#ifndef VRENDER_H
#define VRENDER_H

#include "mainwindow.inc"
#include "mutex.h"
#include "thread.h"
#include "timer.h"


// Want to count down a certain number of late frames before
// we give up and start dropping.

class VRender : public Thread
{
public:
	VRender(MainWindow *mwindow);
	~VRender();

	int arm_playback();
	int close_playback();
	int stop_playback();   // interrupt while playing
	void run();
	int wait_for_startup();
	int wait_for_completion();

	MainWindow *mwindow;
	Mutex startup_lock;
	Timer timer;      // Delay
	Timer framerate_timer;   // Calculate framerate
	int interrupt;
	int framerate_counter;
};




#endif
